#
# $Id: config.tcl,v 1.21 2000/05/08 11:02:38 elias Exp $
# Copyright 1999 Security Dynamics
#
# Description:
# 	Config...
#
# Usage:
#	Dunno yet... 
# 

proc exit__new {{code 0}} {
    global errorInfo
    if {$code && [info exists errorInfo]} {
	puts $errorInfo
	puts -nonewline "Saving to c:/temp/config.error..."
	if [catch {set f [open "c:/temp/config.error" w]} msg] {
	    puts "Uh... can't: $msg"
	} else {
	    puts $f $errorInfo
	    close $f
	    puts done
	}
	flush stdout
	puts -nonewline "Press return"
	flush stdout
	gets stdin s
    }
    exit__org $code
}

set APPDIR {<<INSTALL:APPDIR>>}
set env(PATH) [file nativename $APPDIR/bin]:$env(PATH)
set lib [file join $env(TCL_LIBRARY)]
source $lib/debug.tcl
source $lib/getopt.tcl
source $lib/info.tcl
source $lib/confutils.tcl
source $lib/menutils.tcl
source $lib/confmsg.tcl

#----------------------------------------------------------------------
# Todo -- handle non-interactive mode
#

catch {namespace import CatConf::*}
catch {namespace import CatDbg::*}

if {[llength $argv] > 0} {
    set cmd [lindex $argv 0]

    set cmdlist {
	add  AddCmd	 "Add or modify a port configuration"
	del  DelCmd	 "Delete a port configuration"
	list ListCmd	 "List currentlly configured ports"
	host HostPsdCmd	 "Set Host Virtual Card or password"
	ca   CaCmd	 "Manage trusted CA certificates"
	boks BoksCmd	 "Define Keon 4 domain, nodekey and other parameters"
	els  ElsCmd	 "Define ELS servers"
	show ShowCmd	 "Show current global configuration"
	save SaveCmd     "Save current configuration"
	rest RestCmd     "Restore saved configuration"
    }
    set found 0
    foreach {name proc descr} $cmdlist {
	if {[string compare $cmd $name] == 0} {
	    incr found
	    break
	}
    }
    if !$found {
	if [string length $cmd] {
	    puts stderr "Unknown command: \"$cmd\""
	}
	puts stderr "Usage: config \[ subcommand \] \[ arguments \]"
	puts stderr "Sub-command should be one of:"
	foreach {name ignore descr} $cmdlist {
	    puts stderr [format "  %6s : %s" $name $descr]
	}
	puts stderr "\nEach subcommand takes additional parameters."
	puts stderr "Use \"config <command> help\" for command-specific help."
	puts stderr "\nRunning without arguments enters interactive mode."
	exit 1
    }
    CatInfo::Init {<<INSTALL:ETCDIR>>}
    source $lib/confcmd.tcl
    set argv [lrange $argv 1 end]
    set ret [eval $proc {$argv}]
    switch -- $ret {
	-1 { append proc "Usage"; puts "[eval $proc]"; exit 1 }
	-2 { exit 1 }
    }
    exit 0
} else {
    rename exit exit__org
    rename exit__new exit
}

source $lib/confmenus.tcl

CatInfo::Init {<<INSTALL:ETCDIR>>}
MainMenu
