
namespace eval ::CatModule { ;#

catch {namespace import ::CatDbg::*}

# Make copies of the base system and the boks admin files, for
# use in developing distributions
#
# Also, prepare makefiles in all example directories.
#
proc Install {mode infoarray} {
    upvar $infoarray info

    set reqlist {
	catbase-5.2
	kss4_5.0
	setup.exe
	adf4inst
    }
    set sys NT-5.0
    set target $info(APPDIR)/dist

    switch -exact -- $mode {
	install {

	    # Copy distribiution
	    #
	    catch {Log "Populating $target"}
	    catch {file mkdir $target}
	    catch {
		file copy -force -- [file dirname $info(SRCDIR)]/adf $target
	    }
	    catch {Log "Copying adf files"}
	    catch {file mkdir $target/$sys}
	    foreach s $reqlist {
		if ![file exists $info(SRCDIR)/$s] {
		    catch {Log "$sys/$s does not exist - ignored"}
		} else {
		    catch {Log "Copying $sys/$s"}
		    catch {file delete -force -- $target/$s}
		    catch {file copy -- $info(SRCDIR)/$s $target/$sys}
		}
	    }

	    # Generate example makefiles
	    #
	    catch {Log "Preparing example makefiles:"}
	    set pwd [pwd]
	    foreach d [glob $info(APPDIR)/examples/*] {
		if [file exists $d/Makefile.pp] {
		    if [catch {
			cd $d
			exec $info(APPDIR)/bin/ppmk -o Makefile Makefile.pp
		    } msg] {
			catch { Log " failed ($d): $msg" }
		    } else {
			catch { Log " ok: $d/Makefile" }
		    }
		}
	    }
	    cd $pwd

	    
	}
	uninstall {
	    catch {Log "Deleting $target"}
	    catch { file delete -force -- $target }
	}
    }

    return 1
}


} ;# end CatModule
