
namespace eval ::CatModule { ;#

catch {namespace import ::CatDbg::*}

proc initenv {infoarray} {
    upvar $infoarray info
    global env

    catch {Log "Setting up environment"}
    set lib $info(APPDIR)/lib
    set bin $info(APPDIR)/bin
    set env(TCL_LIBRARY) $lib/tcl
    set env(PATH) $bin:$env(PATH)
    if [info exists env(SHLIB_PATH)] {
	set env(SHLIB_PATH) $lib:$env(SHLIB_PATH)
    } else {
	set env(SHLIB_PATH) $lib
    }
}


proc Install {mode infoarray} {
    upvar $infoarray info

    
    # Unix-specific stuff

    if $info(upgrade) {
	set cfg $info(ETCDIR)/global.cfg
	if [file exists $cfg.upgrade] {
	    Log "Restoring old $cfg"
	    catch {file copy -force -- $cfg.upgrade $cfg}
	}
	return 1
    }

    uplevel #0 [list source $info(APPDIR)/lib/tcl/rc.tcl]

    switch -exact -- $mode {
	install {
	    initenv info
	    CatRC::Add_rc $info(APPDIR)/bin/sdcatagents sdagents
	}
	uninstall {
	    CatRC::Remove_rc sdagents
	    catch {Log "Deleting catsock directory"}
	    catch {file delete -force -- $info(VARDIR)/.catsock}
	    catch {Log "Stopping daemon"}
	    if [catch {exec start stop} msg] {
		set info(MESSAGE) "Failed to stop daemon: $msg"
	    }
	}
    }
    

     

    # Clean out everything in "var", but avoid shooting ourselves
    # in the foot by also removing the "install" directory...
    #
    if {[string compare $mode uninstall] == 0} {
	catch {Log "Cleaning out vardir"}
	foreach f [glob [file join $info(VARDIR) *]] {
	    if [string match */install $f] continue
	    catch {file delete -force -- $f}
	}
    }

    return 1
}

} ;# end CatModule
