#
# $Id: custom.tcl,v 1.1 2000/01/26 14:49:37 elias Exp $
#
# This file demonstrates a simple interface to add agent specific
# parameters to the info tree. This script will be sourced by the
# installation framework. Basically there are two functions one can
# call.
#
# help tag help_message 
#
# parameter tag type info_path prompt_string
#
# The 'parameter' function will create 'info_path' with a value specified
# at the prompt. The 'type' parameter will force the user to specify
# a value of any of the following types.
#
# Type       Meaning
# ----       -------
# y          The answer must be yes or no.
# s          Must specify a string.
# z          Must specify a non-empty string.
# n          The answer must be a numeric value.
# 
# The 'help' function will associate the help message with 'tag'.
# The help message will be displayed if one press '?' on the 
# prompt for that tag.
#

help do_rolemap {
 The Telnet Agent can operate in two modes; SSO and rolemap. If SSO is 
 chosen, the user will be logged in with first matching set of 
 credentials found in the PAC or obtained from the Bridge while the 
 rolemap mode will allow the client or client program to supply 
 account information that is used to map account information in 
 the PAC of from the Bridge.
}

set do_rolemap_prompt "Should rolemapping be used (y/n/?): "

parameter do_rolemap y do_rolemap $do_rolemap_prompt



