#
#@if(0)
#
# $Id: Makefile.pp,v 1.7 2000/01/26 10:00:02 perre Exp $
#
#
# This is a sample Makefile.pp to build an agent.  It should
# be processed with the "ppmk" tool, to generate a Makefile
# which then can be used by "make" (or "nmake")
#
# This file will be processed with "pp" and any text other than
# pp-constructs will end up in the makefile.  The if(0)-endif
# surrounding these paragraphs is one way to ensure that they
# are not copied to the generated makefile.
#
@# pp-comments look like this, and are also removed from the output.
@#
#@endif
#
# If this directory already contains a Makefile, it can be
# updated by running "make Makefile"
#

@# Include the version definition file "ws.pp".
@#
@# This is included in a number of files in the distribution,
@# as well as turned into a header file for inclusion in C programs.
@#
@# The point is to keep version information in a single place.
@# After making changes to this file running "make clean" and "make"
@# should propagate the changes.
@#
@include(ws.pp)

@# The program name should almost certainly be composed of the service
@# name and the version number.  Rememeber that several versions may have
@# to co-exist.
@#
@define(PROG, @SERVICE-@VERSION)

@# TARGETS should always be the first "ppmk" function called.
@# It defines the default targets that should be built.
@# The '@(/)' symbol should be defined to the directory separator
@# in paths, ie '/' on UNIX and '\' on Windows.
@#
@define(VER, adf@(/)@(SERVICE)_@_VERSION)
@define(CONFIG, @VER.gap @VER.properties)
@TARGETS(@PROG @CONFIG)

@# Produce a header file from the version information file.
@#
@VERSIONFILE(ws.pp, version.h)

@# Generate the .gap and .properties files with expanded symbols
@#
@PPFILE(@VER.gap, gap.txt, -iws.pp)
@PPFILE(@VER.properties, properties.txt, -iws.pp)

@# This builds the agent program, using catgen and cat libraries,
@# and including any networking and threading libraries needed
@# by the toolkit.
@#
@# A non-threaded version can, on some platforms, be built by
@# replacing @LIB_THREAD with @LIB_NOTHREAD.
@#
@define(WS_FILES, main.c request.c reply.c utils.c)
@define(WSCAT_FILES, @WS_FILES wscat.c)
@define(USE_CAT, 0)
@if(@USE_CAT)
@COMPILEFLAGS(@WSCAT_FILES, -DUSE_CAT)
@PROGRAM(@PROG, @WSCAT_FILES, @LIB_CAT @LIB_NET @LIB_NOTHREAD)
@else
@PROGRAM(@PROG, @WS_FILES, @LIB_NET)
@endif
